package bbs.pool;
import java.sql.*;
import java.util.*;

public class DBConnection implements Connection {
	private java.sql.Connection connection;

//  Ŀؼ ü ԵǾִ Ǯ
private Pool pool = null;
//  
private boolean inUse;
	private java.util.Date createdTime;
	private Vector statements = new Vector();
/**
 * DBConnection  ּ.
 */
private DBConnection() throws Exception
{
	this(null);
}
/**
 * ޼ҵ  Ͻʽÿ.
 * ۼ ¥: (2001-09-07  1:51:54)
 * @param connection java.sql.Connection
 */
public DBConnection(Connection connection) throws Exception
{
	this(connection, null);
}
/**
 * ޼ҵ  Ͻʽÿ.
 * ۼ ¥: (2001-09-07  2:17:05)
 * @param connection java.sql.Connection
 * @param pool bbs.pool.connpool2001.Pool
 */
public DBConnection(Connection connection, Pool pool) throws Exception
{
	super();
	
	if(connection==null){
		throw new Exception("Ex200109071353(bbs.pool.connpool2001.DBConnection(Connection))"
			+"::connection is null");
	}
	
	this.connection = connection;
	this.pool = pool;
	this.createdTime = new java.util.Date();

	if(pool.VERBOSE){
		System.out.println("bbs.pool.connpool2001.DBConnection(Connection, Pool, boolean), "
			+"200109071422 :: new DBConnection is created");
	}
}
	/**
	 * Clears all warnings reported for this <code>Connection</code> object.	
	 * After a call to this method, the method <code>getWarnings</code>
	 * returns null until a new warning is
	 * reported for this Connection.  
	 *
	 * @exception SQLException if a database access error occurs
	 */
	 
//jdk1.4 Ұ쿡.	 
/*	 
public void setHoldability(int holdability)
                    throws SQLException
	{}
public int getHoldability()
                   throws SQLException
	{return 0;}
public Savepoint setSavepoint()
                       throws SQLException
	{return null;}
public Savepoint setSavepoint(String name)
                       throws SQLException
	{return null;}
public void rollback(Savepoint savepoint)
              throws SQLException
	{}
public void releaseSavepoint(Savepoint savepoint)
                      throws SQLException
	{}
public Statement createStatement(int resultSetType,
                                 int resultSetConcurrency,
                                 int resultSetHoldability)
                          throws SQLException
	{return null;}
public PreparedStatement prepareStatement(String sql,
                                          int resultSetType,
                                          int resultSetConcurrency,
                                          int resultSetHoldability)
                                   throws SQLException
	{return null;}
public CallableStatement prepareCall(String sql,
                                     int resultSetType,
                                     int resultSetConcurrency,
                                     int resultSetHoldability)
                              throws SQLException
	{return null;}
public PreparedStatement prepareStatement(String sql,
                                          int autoGeneratedKeys)
                                   throws SQLException
	{return null;}
public PreparedStatement prepareStatement(String sql,
                                          int[] columnIndexes)
                                   throws SQLException
	{return null;}
public PreparedStatement prepareStatement(String sql,
                                          String[] columnNames)
                                   throws SQLException
	{return null;}
*/

public void clearWarnings() throws SQLException 
{
	connection.clearWarnings();
}
	/**
	 * Releases a Connection's database and JDBC resources
	 * immediately instead of waiting for
	 * them to be automatically released.
	 *
	 * <P><B>Note:</B> A Connection is automatically closed when it is
	 * garbage collected. Certain fatal errors also result in a closed
	 * Connection.
	 *
	 * @exception SQLException if a database access error occurs
	 */
public void close() throws SQLException 
{

	throw new SQLException("Ex200109121318(bbs.pool.connpool2001.DBConnection.close())::"
		+"use returnIntoPool() method");
		
	//connection.close();
}
	/**
	 * Makes all changes made since the previous
	 * commit/rollback permanent and releases any database locks
	 * currently held by the Connection. This method should be
	 * used only when auto-commit mode has been disabled.
	 *
	 * @exception SQLException if a database access error occurs
	 * @see #setAutoCommit 
	 */
public void commit() throws SQLException 
{
	connection.commit();
}
	/**
	 * Creates a <code>Statement</code> object for sending
	 * SQL statements to the database.
	 * SQL statements without parameters are normally
	 * executed using Statement objects. If the same SQL statement 
	 * is executed many times, it is more efficient to use a 
	 * PreparedStatement
	 *
	 * JDBC 2.0
	 *
	 * Result sets created using the returned Statement will have
	 * forward-only type, and read-only concurrency, by default.
	 *
	 * @return a new Statement object 
	 * @exception SQLException if a database access error occurs
	 */
public Statement createStatement() throws SQLException 
{
	Statement stmt = connection.createStatement();
	statements.add(stmt);
	return stmt;
}
	/**
	 * JDBC 2.0
	 *
	 * Creates a <code>Statement</code> object that will generate
	 * <code>ResultSet</code> objects with the given type and concurrency.
	 * This method is the same as the <code>createStatement</code> method
	 * above, but it allows the default result set
	 * type and result set concurrency type to be overridden.
	 *
	 * @param resultSetType a result set type; see ResultSet.TYPE_XXX
	 * @param resultSetConcurrency a concurrency type; see ResultSet.CONCUR_XXX
	 * @return a new Statement object 
	 * @exception SQLException if a database access error occurs
	 */
public Statement createStatement(int resultSetType, int resultSetConcurrency) throws SQLException 
{
	Statement stmt = connection.createStatement(resultSetType, resultSetConcurrency);
	statements.add(stmt);
	return stmt;
}
/**
 * ޼ҵ  Ͻʽÿ.
 * ۼ ¥: (2001-09-21  11:53:54)
 */
protected void finalize() 
{
	try{
		this.connection.close();
	}
	catch(Exception ignored){}
}
	/**
	 * Gets the current auto-commit state.
	 *
	 * @return the current state of auto-commit mode
	 * @exception SQLException if a database access error occurs
	 * @see #setAutoCommit 
	 */
public boolean getAutoCommit() throws SQLException {
	return connection.getAutoCommit();
}
	/**
	 * Returns the Connection's current catalog name.
	 *
	 * @return the current catalog name or null
	 * @exception SQLException if a database access error occurs
	 */
public String getCatalog() throws SQLException 
{
	return connection.getCatalog();
}
/**
 * ޼ҵ  Ͻʽÿ.
 * ۼ ¥: (2001-09-20  6:22:34)
 * @return java.sql.Date
 */
public java.util.Date getCreatedTime() 
{
	return this.createdTime;
}
	/**
	 * Gets the metadata regarding this connection's database.
	 * A Connection's database is able to provide information
	 * describing its tables, its supported SQL grammar, its stored
	 * procedures, the capabilities of this connection, and so on. This
	 * information is made available through a DatabaseMetaData
	 * object.
	 *
	 * @return a DatabaseMetaData object for this Connection 
	 * @exception SQLException if a database access error occurs
	 */
public DatabaseMetaData getMetaData() throws SQLException 
{
	return connection.getMetaData();
}
/**
 * ޼ҵ  Ͻʽÿ.
 * ۼ ¥: (2001-09-07  2:09:38)
 * @return bbs.pool.connpool2001.Pool
 */
public Pool getPool() {
	return pool;
}
	/**
	 * Gets this Connection's current transaction isolation level.
	 *
	 * @return the current TRANSACTION_* mode value
	 * @exception SQLException if a database access error occurs
	 */
public int getTransactionIsolation() throws SQLException 
{
	return connection.getTransactionIsolation();
}
	/**
	 * JDBC 2.0
	 *
	 * Gets the type map object associated with this connection.
	 * Unless the application has added an entry to the type map,
	 * the map returned will be empty.
	 *
	 * @return the <code>java.util.Map</code> object associated 
	 *         with this <code>Connection</code> object
	 */
public java.util.Map getTypeMap() throws SQLException 
{
	return connection.getTypeMap();
}
	/**
	 * Returns the first warning reported by calls on this Connection.
	 *
	 * <P><B>Note:</B> Subsequent warnings will be chained to this
	 * SQLWarning.
	 *
	 * @return the first SQLWarning or null 
	 * @exception SQLException if a database access error occurs
	 */
public SQLWarning getWarnings() throws SQLException 
{
	return connection.getWarnings();
}
	/**
	 * Tests to see if a Connection is closed.
	 *
	 * @return true if the connection is closed; false if it's still open
	 * @exception SQLException if a database access error occurs
	 */
public boolean isClosed() throws SQLException 
{
	return connection.isClosed();
}
/**
 * ޼ҵ  Ͻʽÿ.
 * ۼ ¥: (2001-09-08  1:27:01)
 * @return boolean
 */
public boolean isInUse() {
	return inUse;
}
	/**
	 * Tests to see if the connection is in read-only mode.
	 *
	 * @return true if connection is read-only and false otherwise
	 * @exception SQLException if a database access error occurs
	 */
public boolean isReadOnly() throws SQLException 
{
	return connection.isReadOnly();
}
	/**
	 * Converts the given SQL statement into the system's native SQL grammar.
	 * A driver may convert the JDBC sql grammar into its system's
	 * native SQL grammar prior to sending it; this method returns the
	 * native form of the statement that the driver would have sent.
	 *
	 * @param sql a SQL statement that may contain one or more '?'
	 * parameter placeholders
	 * @return the native form of this statement
	 * @exception SQLException if a database access error occurs
	 */
public String nativeSQL(String sql) throws SQLException {
	return connection.nativeSQL(sql);
}
	/**
	 * Creates a <code>CallableStatement</code> object for calling
	 * database stored procedures.
	 * The CallableStatement provides
	 * methods for setting up its IN and OUT parameters, and
	 * methods for executing the call to a stored procedure.
	 *
	 * <P><B>Note:</B> This method is optimized for handling stored
	 * procedure call statements. Some drivers may send the call
	 * statement to the database when the method <code>prepareCall</code>
	 * is done; others
	 * may wait until the CallableStatement is executed. This has no
	 * direct effect on users; however, it does affect which method
	 * throws certain SQLExceptions.
	 *
	 * JDBC 2.0
	 *
	 * Result sets created using the returned CallableStatement will have
	 * forward-only type and read-only concurrency, by default.
	 *
	 * @param sql a SQL statement that may contain one or more '?'
	 * parameter placeholders. Typically this  statement is a JDBC
	 * function call escape string.
	 * @return a new CallableStatement object containing the
	 * pre-compiled SQL statement 
	 * @exception SQLException if a database access error occurs
	 */
public CallableStatement prepareCall(String sql) throws SQLException 
{
	CallableStatement cstmt = connection.prepareCall(sql);
	statements.add(cstmt);
	return cstmt;
}
	/**
	 * JDBC 2.0
	 *
	 * Creates a <code>CallableStatement</code> object that will generate
	 * <code>ResultSet</code> objects with the given type and concurrency.
	 * This method is the same as the <code>prepareCall</code> method
	 * above, but it allows the default result set
	 * type and result set concurrency type to be overridden.
	 *
	 * @param resultSetType a result set type; see ResultSet.TYPE_XXX
	 * @param resultSetConcurrency a concurrency type; see ResultSet.CONCUR_XXX
	 * @return a new CallableStatement object containing the
	 * pre-compiled SQL statement 
	 * @exception SQLException if a database access error occurs
	 */
public CallableStatement prepareCall(String sql, int resultSetType, int resultSetConcurrency) throws SQLException 
{
	CallableStatement cstmt 
		= connection.prepareCall(sql, resultSetType, resultSetConcurrency);
	statements.add(cstmt);
	return cstmt;
}
	/**
	 * Creates a <code>PreparedStatement</code> object for sending
	 * parameterized SQL statements to the database.
	 * 
	 * A SQL statement with or without IN parameters can be
	 * pre-compiled and stored in a PreparedStatement object. This
	 * object can then be used to efficiently execute this statement
	 * multiple times.
	 *
	 * <P><B>Note:</B> This method is optimized for handling
	 * parametric SQL statements that benefit from precompilation. If
	 * the driver supports precompilation,
	 * the method <code>prepareStatement</code> will send
	 * the statement to the database for precompilation. Some drivers
	 * may not support precompilation. In this case, the statement may
	 * not be sent to the database until the <code>PreparedStatement</code> is
	 * executed.  This has no direct effect on users; however, it does
	 * affect which method throws certain SQLExceptions.
	 *
	 * JDBC 2.0
	 *
	 * Result sets created using the returned PreparedStatement will have
	 * forward-only type and read-only concurrency, by default.
	 *
	 * @param sql a SQL statement that may contain one or more '?' IN
	 * parameter placeholders
	 * @return a new PreparedStatement object containing the
	 * pre-compiled statement 
	 * @exception SQLException if a database access error occurs
	 */
public PreparedStatement prepareStatement(String sql) throws SQLException 
{
	PreparedStatement pstmt = connection.prepareStatement(sql);
	statements.add(pstmt);
	return pstmt;
}
	/**
	 * JDBC 2.0
	 *
	 * Creates a <code>PreparedStatement</code> object that will generate
	 * <code>ResultSet</code> objects with the given type and concurrency.
	 * This method is the same as the <code>prepareStatement</code> method
	 * above, but it allows the default result set
	 * type and result set concurrency type to be overridden.
	 *
	 * @param resultSetType a result set type; see ResultSet.TYPE_XXX
	 * @param resultSetConcurrency a concurrency type; see ResultSet.CONCUR_XXX
	 * @return a new PreparedStatement object containing the
	 * pre-compiled SQL statement 
	 * @exception SQLException if a database access error occurs
	 */
public PreparedStatement prepareStatement(
	String sql, int resultSetType, int resultSetConcurrency) 
throws SQLException 
{
	PreparedStatement pstmt 
		= connection.prepareStatement(sql, resultSetType, resultSetConcurrency);
	statements.add(pstmt);
	return pstmt;
}
/**
 * pool ư
 * ۼ ¥: (2001-09-12  1:17:35)
 */
public void returnIntoPool() throws Exception
{

	// ش Ŀؼ  Statement   
	Statement stmt = null;
	for(Enumeration enu = statements.elements()
		; enu.hasMoreElements(); stmt = (Statement)enu.nextElement())
	{
		try{
			stmt.close();
		}
		catch(Exception ignored){}
	}

	//  Statement list 
	statements.clear();
	
	pool.returnConnection(this);
}
	/**
	 * Drops all changes made since the previous
	 * commit/rollback and releases any database locks currently held
	 * by this Connection. This method should be used only when auto-
	 * commit has been disabled.
	 *
	 * @exception SQLException if a database access error occurs
	 * @see #setAutoCommit 
	 */
public void rollback() throws SQLException 
{
	connection.rollback();
}
	/**
	 * Sets this connection's auto-commit mode.
	 * If a connection is in auto-commit mode, then all its SQL
	 * statements will be executed and committed as individual
	 * transactions.  Otherwise, its SQL statements are grouped into
	 * transactions that are terminated by a call to either
	 * the method <code>commit</code> or the method <code>rollback</code>.
	 * By default, new connections are in auto-commit
	 * mode.
	 *
	 * The commit occurs when the statement completes or the next
	 * execute occurs, whichever comes first. In the case of
	 * statements returning a ResultSet, the statement completes when
	 * the last row of the ResultSet has been retrieved or the
	 * ResultSet has been closed. In advanced cases, a single
	 * statement may return multiple results as well as output
	 * parameter values. In these cases the commit occurs when all results and
	 * output parameter values have been retrieved.
	 *
	 * @param autoCommit true enables auto-commit; false disables
	 * auto-commit.  
	 * @exception SQLException if a database access error occurs
	 */
public void setAutoCommit(boolean autoCommit) throws SQLException 
{
	connection.setAutoCommit(autoCommit);
}
	/**
	 * Sets a catalog name in order to select 	
	 * a subspace of this Connection's database in which to work.
	 * If the driver does not support catalogs, it will
	 * silently ignore this request.
	 *
	 * @exception SQLException if a database access error occurs
	 */
public void setCatalog(String catalog) throws SQLException 
{
	connection.setCatalog(catalog);
}
/**
 * ޼ҵ  Ͻʽÿ.
 * ۼ ¥: (2001-09-08  1:27:01)
 * @param newInUse boolean
 */
public void setInUse(boolean newInUse) {
	inUse = newInUse;
}
/**
 * ޼ҵ  Ͻʽÿ.
 * ۼ ¥: (2001-09-07  2:09:38)
 * @param newPool bbs.pool.connpool2001.Pool
 */
void setPool(Pool newPool) {
	pool = newPool;
}
	/**
	 * Puts this connection in read-only mode as a hint to enable 
	 * database optimizations.
	 *
	 * <P><B>Note:</B> This method cannot be called while in the
	 * middle of a transaction.
	 *
	 * @param readOnly true enables read-only mode; false disables
	 * read-only mode.  
	 * @exception SQLException if a database access error occurs
	 */
public void setReadOnly(boolean readOnly) throws SQLException 
{
	connection.setReadOnly(readOnly);
}
	/**
	 * Attempts to change the transaction
	 * isolation level to the one given.
	 * The constants defined in the interface <code>Connection</code>
	 * are the possible transaction isolation levels.
	 *
	 * <P><B>Note:</B> This method cannot be called while
	 * in the middle of a transaction.
	 *
	 * @param level one of the TRANSACTION_* isolation values with the
	 * exception of TRANSACTION_NONE; some databases may not support
	 * other values
	 * @exception SQLException if a database access error occurs
	 * @see DatabaseMetaData#supportsTransactionIsolationLevel 
	 */
public void setTransactionIsolation(int level) throws SQLException 
{
	connection.setTransactionIsolation(level);
}
	/**
	 * JDBC 2.0
	 *
	 * Installs the given type map as the type map for
	 * this connection.  The type map will be used for the
	 * custom mapping of SQL structured types and distinct types.
	 *
	 * @param the <code>java.util.Map</code> object to install
	 *        as the replacement for this <code>Connection</code>
	 *        object's default type map
	 */
public void setTypeMap(java.util.Map map) throws SQLException 
{
	connection.setTypeMap(map);
}
}
