/**
	Title: 		Ƽ Խ
	Copyright:	Copyright(c)2002
	Author:		̸
	Email:		lmy20@naver.com
	Company:	
	Created on:	2002.01.22
	Description:	MultiPartParse.java
	
	--ڹٴ ۼ ҽ Ͽ 
	
	==============================================================================
	 
	NO		¥		۾		
	
	==============================================================================
**/

package bbs.upload;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;
import bbs.*;

public class MultiPartParser {
	
	private Vector					parameters			= new Vector();
	private DataInputStream	servletIn					= null;
	private FileOutputStream	fileOut					= null;
	private final int 				fileBufferMax			= 1024;
	private final int 				fileBufferMin			= 64;
	private byte[]					fileBuffer				= new byte[fileBufferMax];
	private int						fileBufferLength		= 0;
	private boolean				endOfFile				= false;
	private int 						leadBufferLength		= 0;
	private byte[] 				leadBuffer				= new byte[100];
	private byte[] 				delimiter				= new byte[35];
	private byte[] 				nameHeader			= new String("Content-Disposition: form-data; name=").getBytes();	
	private byte					oneByte					= 0;
	
	private final byte	NEWLINE			= (byte)'\n';
	private final byte	CR					= (byte)'\r';
	private final byte	DASH				= (byte)'-';
	private final byte	EQUAL				= (byte)'=';
	private final byte	SPACE				= (byte)' ';
	private final byte	SEMICOLON		= (byte)';';
	private final byte	DOUBLEQUOTE	= (byte)'\"';

	private String targetDir	=".";

	private String	parmName;
	private String	parmValue;
	private File		saveFile;
	private int filetotsize1 = 0;
	private int fileMaxSize = 0;
		
	public MultiPartParser(){}
	public MultiPartParser(int fileMaxSizeP)
	{
		this.fileMaxSize = fileMaxSizeP;
	}
	
	public MultiPartParser( HttpServletRequest req, String dir ) throws Exception {
		
		setTargetDir(dir);
		getRequest(req);

	}
	
	public void getRequest(HttpServletRequest req) throws Exception{
		servletIn = new DataInputStream(req.getInputStream());		
		makeParameters();
	}
	
	/*
	///////////////////////////////
		parameter make function
	///////////////////////////////
	*/
		
	private void makeParameters() throws Exception {
			
		// delimiter cut
		if (servletIn.read(delimiter) != delimiter.length) {return;}
		
				
		while(!endOfFile) {
			
			parmName			= null;
			parmValue			= null;
			saveFile				= null;
		
			try {	
				
				while(servletIn.readByte() != NEWLINE);//new line skip

				// parm name make
				getParmName();
				
				// parm value make
				if( oneByte == NEWLINE ) {	// field value

					while(servletIn.readByte() != NEWLINE);//new line skip
					
					getParmValue(); // parm value process

				}
				else if ( oneByte == SEMICOLON) { // file value

					servletIn.readByte(); //space line skip
						
					getFileName(); // file value process

				}
			
		}catch(EOFException e) 
		{ 
			endOfFile = true; 
		}
			
			addParameter(); // add parameter
			
		}
		
	}
	
	
	/*
	//////////////////////////////////
		parameter add function
	//////////////////////////////////
	*/
	private void addParameter() {
		
		if (parmName == null) return;
		
		MultiPartParameter mp = new MultiPartParameter(parmName);
		
		mp.setParmValue(parmValue);
		mp.setSaveFile(saveFile);
		
		parameters.addElement(mp);
		
	}

	
	/*
	//////////////////////////////////
		parameter name make function
		- read until eof, space, semicolon
	//////////////////////////////////
	*/
	private void getParmName()  throws Exception {
		
		byte[] data = new byte[200];
		int length;
		
		// field name header skip
		while(servletIn.readByte() != EQUAL);
		
		// name make unitl newline or semicolon
		for ( length=0; true; length++ ) {
			
			oneByte = servletIn.readByte();
			
			if(oneByte == NEWLINE || oneByte == SEMICOLON) {
				break;
			}
			else {
				data[length] = oneByte;
			}
					
		}
		
		parmName = trimParm(new String(data,0,length));
		
	}
	
	
	/*
	//////////////////////////////////
		parameter value make function
		- read until eof, delimiter
	//////////////////////////////////
	*/
	private void getParmValue()  throws Exception{
		
		byte[] data = new byte[1024];
		int length	= 0;
	
		while(true) {
			
				oneByte = servletIn.readByte();	
				
				if (oneByte == DASH) {
					if(isDelimiter(oneByte)) {
						break;
					}
					else {
						 for(int i = 0; i < leadBufferLength ; i++) {
						 	data[length] = leadBuffer[i];
						 	length++;
						 	data = checkBuffer(data, length);
						 }
					}
				}
				else {
					data[length] = oneByte;
					length ++;
					data = checkBuffer(data, length);
					
				}
		}
		parmValue = trimParm(new String( data, 0, length,"ksc5601"));
	}
	
	/* 
	/////////////////////////////////////
	// buffer check
	/////////////////////////////////////
	*/
	
	private byte[] checkBuffer( byte[] buff, int length ) {
		
		if(buff == null) { return null; }
		
		if ((buff.length - 10) <= length) {
			byte[] newBuff = new byte[ buff.length * 2 ];
			System.arraycopy(buff,0,newBuff,0,buff.length);
			
			return newBuff;
		}
	
		return buff;
		
	}

	
	private Enumeration getMultiPartParameters() { return(parameters.elements()); }

	/*
	/////////////////////////////////////
		file save and name make function
		read until eof, delimiter
	/////////////////////////////////////
	*/
	private void getFileName()  throws Exception {
		
		byte[]	data = new byte[200];
		int length = 0;
		
		// skip filename header
		while(servletIn.readByte() != EQUAL);
				
		// get file name
		while((oneByte = servletIn.readByte()) != NEWLINE) {
			data[length] = oneByte;
			length ++;
		}
		parmValue = trimParm(new String(data,0,length));

		// null file skip
		if(parmValue == null || parmValue.length() == 0) {
			while(true) {
				while(true)
				{
					oneByte = servletIn.readByte();
					
					if(oneByte != CR && oneByte != NEWLINE) {break;}
				}
				if(isDelimiter(oneByte)){return;}
			}
		}
	
		// target file open
		fileOpen();
		
		// content-type skip
		while((oneByte = servletIn.readByte()) != NEWLINE){};
		// new line skip
		servletIn.readByte();
		servletIn.readByte();

		
		// file write
		
		length = 0;
		
		while(true) {
			
			oneByte = servletIn.readByte();	

			if (oneByte == NEWLINE) {
				
				data[length] = oneByte;
				length ++;

				oneByte = servletIn.readByte();
				data[length] = oneByte;
				length ++;

				if (oneByte == DASH) {
					
					if(isDelimiter(oneByte)) {
						break;
					}
					else {
						if(length > 0) {fileWrite(data,0,length);length=0;}
						fileWrite(leadBuffer,1,leadBufferLength - 1);
					}
				}
				else {
					if(length > 0) {fileWrite(data,0,length);length=0;}
				}
			}
			/* modify */
			else if (oneByte == DASH) {
				
				data[length] = oneByte;
				length ++;
				
				if(isDelimiter(oneByte)) {
					break;
				}
				else {
					if(length > 0) {fileWrite(data,0,length);length=0;}
					fileWrite(leadBuffer,1,leadBufferLength - 1);
				}
			}
			
			/* end modify */
			else {
				
				if(length > 0) {fileWrite(data,0,length);length=0;}
				
				data[length] = oneByte;
				length ++;

			}

		}
		
		
		length --; //dash skip
		length --; // newline skip
		
			
		if(length > 0) {
			if(data[length - 1] == CR) { length --;}
			fileWrite(data,0,length);
		}		
		fileClose();
				
	}
	
	/*
	//////////////////////////////////
		file buffer open
	//////////////////////////////////
	*/
	private void fileOpen() throws Exception{
		
		saveFile = getTargetFile();
		fileOut    = new FileOutputStream(saveFile);
		fileBufferLength = 0;
		
	}
	
	/*
	//////////////////////////////////
		file bufferedWrite
	//////////////////////////////////
	*/
	private void fileWrite(byte[] inData,int startIndex, int inLength)  throws Exception {
		
		/*ũ üũ*/
		filetotsize1 = filetotsize1+inLength;
		if(filetotsize1 > fileMaxSize)
		{
			fileClose();
			if(saveFile.exists())
			{
				if(saveFile.delete()) System.out.println("ϻϷ");;
			}
			throw new IOException("File size error["+(fileMaxSize/1024/1024)+"M]");
		}
		/*-------------*/
		
		for(int i = 0; i < inLength; i++) {
			
			if(fileBufferLength == fileBufferMax) {
				fileBufferFlush();
				
			}
			
			fileBuffer[fileBufferLength++] = inData[startIndex++];
			
		}
		
	}
	
	/*
	//////////////////////////////////
		file buffer half flush
	//////////////////////////////////
	*/
	private void fileBufferFlush() throws Exception {
		
		fileOut.write(fileBuffer,0,fileBufferMin);
		
		fileBufferLength = 0;
		
		for(int i=fileBufferMin;i < fileBufferMax; i++) {
			fileBuffer[fileBufferLength++] = fileBuffer[i];
		}
		
	}
		
	/*
	//////////////////////////////////
		file close
	//////////////////////////////////
	*/
	private void fileClose() throws Exception{
		
		if (fileBufferLength > 0) { // buffer clear
			
			if(fileBuffer[fileBufferLength -1] == CR) {fileBufferLength --;}
			
			fileOut.write(fileBuffer,0,fileBufferLength);
			fileBufferLength = 0;
		}
		
		fileOut.close();	
		
	}
	

	/*
	//////////////////////////////////
		is delimiter ?  function
	//////////////////////////////////
	*/
	private boolean isDelimiter(byte initByte)  throws Exception {

		leadBufferLength   = 0;
		
		leadBuffer[leadBufferLength] = initByte;
		leadBufferLength ++;
				
		while(true) {
			
			oneByte = servletIn.readByte();	
			leadBuffer[leadBufferLength] = oneByte;
			leadBufferLength ++;
		
			if( compareBytes(delimiter, leadBuffer, leadBufferLength)) {
	
				if (leadBufferLength == delimiter.length) {
					return true;
				}
			}
			else {
				return false;
			}
				
		}
		
	}

	
	/*
	//////////////////////////////////
		compare byte arrays function
	//////////////////////////////////
	*/
	private boolean compareBytes(byte[] source, byte[] target, int length)  throws Exception {

		if (source == null || target == null) return false;

		if(source.length < length || target.length < length) return false;

		for(int i=0; i < length; i++) {
			if (source[i] != target[i]) return false;
		}
		
		return true;

	}
	/*
	//////////////////////////////////
		trim parameter function
	//////////////////////////////////
	*/
	private String trimParm(String s) throws Exception{
		
		String str;

		if (s == null) return null;
		
		byte[] src = (s.trim()).getBytes();
		
		if (src.length == 0) return null;
	
		if (src[0] == DOUBLEQUOTE) src[0] = SPACE;
		if (src[src.length -1] == DOUBLEQUOTE) src[src.length -1] = SPACE;
		
		//str = ((new String(src)).trim());
		
		str = (new String(src,"8859_1")).trim();
		
		if(str != null && str.length() == 0 ) {str = null;}
		
		return(str);
		
	}
	
	/*
	//////////////////////////////////
		set target dir
	//////////////////////////////////
	*/
	public void setTargetDir(String dir) throws Exception{	
		if (dir == null || !(new File(dir)).isDirectory()) {
			throw new Exception("invalid Directory");
		}
		targetDir = dir;
	}
	public String getTargetDir() throws Exception{		
		return targetDir;
	}

	/*
	//////////////////////////////////
		get target file
	//////////////////////////////////
	*/
	private File getTargetFile() throws Exception{
	
		String fileName,surfix, prefix,serialSurfix;
		int pointIndex, serial = 0;
		File file;
	
		char otherSeparator;
		
		otherSeparator = File.separatorChar == '/' ? '\\' : '/';
	
		String tmpName = new String(parmValue.getBytes("8859_1"),"ksc5601");
		
		tmpName = tmpName.replace(otherSeparator, File.separatorChar);
		
		fileName = (new File(tmpName)).getName();
		
		pointIndex = fileName.lastIndexOf('.');
		if (pointIndex == -1 || pointIndex == (fileName.length() - 1)) {
			prefix = fileName;
			surfix = null;
		}
		else {
			prefix = fileName.substring(0,pointIndex);
			surfix = fileName.substring(pointIndex + 1);
		}
		
		fileName = surfix == null ? prefix : prefix + "." + surfix;
		file = new File(targetDir,fileName);
		
		while(file.exists()){
			
			serialSurfix = String.valueOf(serial);
			fileName = surfix == null ? prefix + serialSurfix : prefix + serialSurfix + "." + surfix;
			file = new File(targetDir,fileName);
			
			serial ++;
			
		}
		
		return file;

	}
	
	public String getParameter(String name){
		
		MultiPartParameter parm;
		
		Enumeration enumParms = getMultiPartParameters();
		
		while(enumParms.hasMoreElements()) {
				
			parm = (MultiPartParameter)enumParms.nextElement();
			
			if(name.equals(parm.getParmName())){ return (parm.getParmValue());}
		   
		}

		return null;
		
	}
	
	public File getFile(String name){
	
		MultiPartParameter parm;
		
		Enumeration enumParms = getMultiPartParameters();
		
		while(enumParms.hasMoreElements()) {
				
			parm = (MultiPartParameter)enumParms.nextElement();
			
			if(name.equals(parm.getParmName())){ 
				
				return (parm.getSaveFile());}
		   
		}

		return null;	
		
	}
	
	public String[] getParameterValues(String name){
		
		Vector values = new Vector();
		String[] stringValues;
		int length;
		MultiPartParameter parm;
		
		Enumeration enumParms = getMultiPartParameters();
		
		while(enumParms.hasMoreElements()) {
				
			parm = (MultiPartParameter)enumParms.nextElement();
			
			if(name.equals(parm.getParmName())){ values.addElement(parm.getParmValue());}
		   
		}

		length = values.size();
		stringValues = new String[length];
		
		for(int i=0; i < length; i++) {
			stringValues[i] = (String)values.elementAt(i);
		}
		
		return (stringValues);
		
	}
	
	public Enumeration getParameterNames(){
		
		Vector names	= new Vector();
		
		MultiPartParameter parm;
		
		Enumeration enumParms = getMultiPartParameters();
		
		while(enumParms.hasMoreElements()) {
				
			parm = (MultiPartParameter)enumParms.nextElement();
			
			names.addElement(parm.getParmName());
		   
		}
		
		return(names.elements());
	}
	
	
	/*
	inner class MutiPartParameter
	*/
	
	public class MultiPartParameter {
	
		String parmName;
		String parmValue;
		File	 saveFile;
	
		public MultiPartParameter(String name) {
			parmName = name;
		}
	
		public void setParmName(String name) { parmName = name; }
		public void setParmValue(String value) { parmValue = value; }
		public void setSaveFile(File file) { saveFile = file; }
	
		public String getParmName() { return parmName; }
		public String getParmValue() { return parmValue; }
		public File getSaveFile() {return saveFile; }
	
	}
}	
			