package bbs.pool;
import java.util.*;
import java.sql.*;

public class Pool {




// Pool ⺻ instance id
public final static String DEFAULT_ID = "bbs.pool.connpool2001.Pool.DEFAULT_POOL_ID";



	

// 밡 Ŀؼǵ Ʈ
private java.util.Vector pool = new Vector();

// pool id
private java.lang.String id;


	private PoolContainer poolContainer = null;
	boolean VERBOSE = false;
	public final static int NOMAL_CONNECTION_COUNT = 5;

// 峭 Ŀؼ ϴ 
private BadConnKiller badConnKiller;

// BadConnKiller thread ⵿ 
public final static int BadConnKiller_RUNNING_TERM = 300000;
// BadConnKiller ѹ ׽Ʈ ĿؼǼ
public final static int BadConnKiller_FETCH_SIZE = 3;
//  ִ PoolChecker thread count
private java.lang.Integer poolCheckerThreadCount = new Integer(0);
// ǮüĿ   డ   
public final static int DEFAULT_PoolChecker_THREAD_COUNT = 5;
// jdbc url
private java.lang.String jdbcURL;
// jdbc driver
private java.lang.String jdbcDriver;
// db user
private java.lang.String dbUser;
// db user passwd
private java.lang.String dbUserPasswd;
	public final static long CONN_ALIVE_TIME = 600000;
/**
 * Pool  ּ.
 */
public Pool() throws Exception
{
	this(null, null);
}
/**
 * Pool  ּ.
 */
public Pool(String id, PoolContainer container) throws Exception
{
	// id Ǯ ̳ʸ 
	this.id = id;
	this.poolContainer = container;

	if(VERBOSE){
		System.out.println("bbs.pool.connpool2001.Pool.Pool(String, PoolContainer) :: new Pool "
			+"created(pool id = "+id+")");
	}
}
/**
 * PoolChecker thread ī͸ 1
 * ۼ ¥: (2001-09-11  9:28:22)
 */
synchronized void decreasePoolCheckerThreadCount() 
{
	
	synchronized (this.poolCheckerThreadCount) {
		int current = poolCheckerThreadCount.intValue();
		if(--current<0)
			current = 0;
		poolCheckerThreadCount = new Integer(current);
	}
	
}
/**
 * Ǯ Ŀؼ 
 * ۼ ¥: (2001-09-07  1:33:09)
 * @return bbs.pool.connpool2001.DBConnection
 */
synchronized public DBConnection getConnection() throws Exception
{

	//   db info õ  ¶ ͼ
	if(this.jdbcDriver==null || this.jdbcURL==null){
		throw new Exception ("Ex200109111136(bbs.pool.connpool2001.Pool.getConnection())::"
			+"db information is not yet set(jdbcURL, jdbcDriver... use Pool.setDBInfo(....) method");
	}
	
	try{
		//  Ǯ ִٸ  
		while(this.getCountAvailable()<1){
			try{
				wait();
			}
			catch(InterruptedException ie){}
		}

		// pool Ŀؼ ϳ  뿩Ʈ ϰ  Ŀؼ Ѵ.
		DBConnection dbconn = null;
		synchronized (pool) {
			if(getCountAvailable()>0){
				dbconn = (DBConnection)pool.get(0);
				if(dbconn!=null){
					pool.remove(0);
				}
			}
		}
		
		startupPoolChecker();
			
		if(false){
			System.out.println("bbs.pool.connpool2001.Pool.getConnection(), 200109081729 :: "
				+"CURRENT_CONNECTION_COUNT = "+getCountAvailable());
		}

		return dbconn;
		
	}
	catch(Exception e){
		throw new Exception("Ex200109081655(bbs.pool.connpool2001.Pool.getConnection())::"+e);
	}
	
	
}
/**
 *  밡 Ŀؼ  Ѵ.
 * ۼ ¥: (2001-09-08  2:33:34)
 * @return int
 */
public int getCountAvailable() {

	return pool.size();
	
}
/**
 * return db user string of this pool
 * ۼ ¥: (2001-09-11  11:31:26)
 * @return java.lang.String
 */
public String getDbUser() 
{
	return this.dbUser;
}
/**
 * return db user passwd of this pool
 * ۼ ¥: (2001-09-11  11:31:59)
 * @return java.lang.String
 */
public String getDbUserPasswd() 
{
	return this.dbUserPasswd;
}
/**
 * return jdbc driver string of this pool
 * ۼ ¥: (2001-09-11  11:30:48)
 * @return java.lang.String
 */
public String getJdbcDriver() 
{
	return this.jdbcDriver;
}
/**
 * return jdbcURL of this pool
 * ۼ ¥: (2001-09-11  11:30:02)
 * @return java.lang.String
 */
public String getJdbcURL() 
{
	return this.jdbcURL;
}
/**
 *  PoolChecker thread  
 * ۼ ¥: (2001-09-11  9:35:56)
 * @return java.lang.Integer
 */
public Integer getPoolCheckerThreadCount() 
{
	return poolCheckerThreadCount;
}
/**
 * PoolChecker thread ī͸ 1
 * ۼ ¥: (2001-09-11  9:25:00)
 */
synchronized void incresePoolCheckerThreadCount() 
{
	
	synchronized (this.poolCheckerThreadCount) {
		int current = poolCheckerThreadCount.intValue();
		poolCheckerThreadCount = new Integer(++current);
	}
	
}
/**
 * ο Ŀؼ Ǯ ߰Ѵ.
 * ۼ ¥: (2001-09-08  2:36:37)
 * @param conn bbs.pool.connpool2001.DBConnection
 */
synchronized void putConnection(DBConnection connection) throws Exception
{

	try{

		//  Ŀؼ  Ǯ ⺻ ̴Ѵٸ ޾Ƶ
		synchronized (pool) {
			int toAddCount = Pool.NOMAL_CONNECTION_COUNT - getCountAvailable();
			if(toAddCount>0 && connection!=null){
				pool.add(connection);
			}
		}

		if(VERBOSE){
			System.out.println("bbs.pool. connpool2001.Pool.putNewConnection(DBConnection), "
				+"200109081731 :: CURRENT_CONNECTION_COUNT = "+getCountAvailable());

		}
		
		notifyAll();
	}
	catch(Exception e){
		throw new Exception("Ex200109081659(bbs.pool.connpool2001.Pool."
			+"putNewConnection(DBConnection))::"+e);
	}
	
}
/**
 *   Ŀؼ  
 * ۼ ¥: (2001-09-10  4:11:03)
 * @param connection bbs.pool.connpool2001.DBConnection
 */
public void returnConnection(DBConnection connection)
throws Exception
{

	// Ŀؼ   ʾҴٸ ޾Ƶ
	if(connection!=null && !connection.isClosed()){
		
		putConnection(connection);
	}
	
}
/**
 *  Ŀؼ 
 * ۼ ¥: (2001-09-11  9:10:09)
 * @param vecConns java.util.Vector
 */
public void returnConnections(Vector vecConns) 
{
	
	if(vecConns!=null)
		for(int i=0; i<vecConns.size(); i++){
			try{
				returnConnection((DBConnection)vecConns.get(i));
			}
			catch(Exception e){
				if(VERBOSE){
					System.out.println("Ex200109110912(bbs.pool.connpool2001.Pool."
						+"returnConnections(Vector) :: "+e);
				}
			}
		}
	
}
/**
 * Ǯ Ŀؼ  ʿ db info 
 * ۼ ¥: (2001-09-11  11:27:35)
 * @param jdbcURL java.lang.String
 * @param jdbcDriver java.lang.String
 * @param dbUser java.lang.String
 * @param dbUserPasswd java.lang.String
 */
public void setDBInfo(String jdbcURL, String jdbcDriver, String dbUser, String dbUserPasswd)
throws Exception
{

	if(this.jdbcURL!=null){
		throw new Exception("Ex200109221324(bbs.pool.connpool2001.Pool.setDBInfo(String, "
			+"String, String, String))::db info already set");
	}
		
	this.jdbcURL = jdbcURL;
	this.jdbcDriver = jdbcDriver;
	this.dbUser = dbUser;
	this.dbUserPasswd = dbUserPasswd;

	
	// ִ Ǯ ä  üĿ带 ⵿Ѵ.
	startupPoolChecker();

	// 峭 Ŀؼǵ ϴ 带 ⵿Ų.
	startupBadConnKiller();
	
}
/**
 * ޼ҵ  Ͻʽÿ.
 * ۼ ¥: (2001-09-07  9:57:46)
 * @param newVERBOSE boolean
 */
public void setVERBOSE(boolean newVERBOSE) {
	VERBOSE = newVERBOSE;
	if(this.poolContainer!=null){
		this.poolContainer.setVERBOSE(newVERBOSE);
	}
}
/**
 * startup BadConnKiller thread 
 * ۼ ¥: (2001-09-10  4:37:24)
 */
synchronized private void startupBadConnKiller() 
{

	if(badConnKiller==null){
		badConnKiller = new BadConnKiller(this);
		badConnKiller.start();
	}
	
}
/**
 * pool checker thread ư    ⵿Ų.
 * ۼ ¥: (2001-09-08  2:14:09)
 */
void startupPoolChecker() 
{

/*
	if(isVERBOSE()){
		System.out.println("bbs.pool.connpool2001.Pool.startupPoolChecker(), 200109081704 :: "
			+"trying to startup PoolChecker thread");
	}
*/

	synchronized (poolCheckerThreadCount) {
		if(poolCheckerThreadCount.intValue()<Pool.DEFAULT_PoolChecker_THREAD_COUNT){

			PoolChecker poolChecker = new PoolChecker(this);
			incresePoolCheckerThreadCount();
			poolChecker.start();
		}
	}

	
/*
	else{

		if(isVERBOSE()){
			System.out.println("bbs.pool.connpool2001.Pool.startupPoolChecker(), 200109081706 :: "
				+" PoolChecker thread is already running");
		}
	}
*/

	
}
}
