package bbs.pool;
import java.sql.*;
import java.util.*;

class PoolChecker extends Thread {
	private Pool pool;
/**
 * PoolChecker  ּ.
 */
public PoolChecker(Pool poolToCheck) {
	super();

	this.pool = poolToCheck;

	if(pool.VERBOSE){
		System.out.println("bbs.pool.connpool2001.PoolChecker.PoolChecker(Pool) :: "
			+"poolChecker created(current PoolChecker thread count = "
			+pool.getPoolCheckerThreadCount().intValue()+")");
	}
}
/**
 * ο Ŀؼ Ѵ.
 * ۼ ¥: (2001-09-08  2:24:11)
 * @return bbs.pool.connpool2001.DBConnection
 */
private DBConnection createConnection() throws Exception
{

	String connUrl = pool.getJdbcURL();
	String user = pool.getDbUser();
	String passwd = pool.getDbUserPasswd();

	if(connUrl==null || pool.getJdbcDriver()==null){
		throw new Exception("Ex200109111603(bbs.pool.connpool2001.PoolChecker."
			+"createconnection())::db info is not yet set");
	}
	
	/* for informix
	if(user!=null)
		connUrl = connUrl+";user="+user;
	if(passwd!=null)
		connUrl = connUrl+";password="+passwd;
	*/

	Class.forName(pool.getJdbcDriver()).newInstance();
	Connection conn = null;
	if(user==null || passwd==null){
		conn = DriverManager.getConnection(connUrl);
	}
	else{
		conn = DriverManager.getConnection(connUrl, user, passwd);
	}
	
	
	return new DBConnection(conn, pool);
	
}
/**
 * 尡   ī͸ ҽŴ
 * ۼ ¥: (2001-09-11  9:33:08)
 */
protected void finalize() 
{
	
	pool.decreasePoolCheckerThreadCount();
	
}
/**
 * Ǯ ¸ üũϰ ¸ Ű Ǯ ڶ Ŀؼ  
 * ۼ ¥: (2001-09-08  2:01:25)
 */
public void run() 
{

	try{
		
		if(pool.VERBOSE){
			System.out.println("bbs.pool.connpool2001.PoolChecker.run(), 200109081428 :: "
				+"poolChecker thread is started");
		}

		// Ǯ Ŀؼ 񷮿 ̴ϴ ŭ Ŀؼ 
		Vector newConns = new Vector();
		int toCreate = Pool.NOMAL_CONNECTION_COUNT - pool.getCountAvailable();
		for(int i=0; i<toCreate; i++){
			try{
				// pool  Ŀؼ ߰Ѵ.
				pool.putConnection(createConnection());
			}
			catch(Exception e){
				if(pool.VERBOSE){
					System.out.println("######################################################");
					e.printStackTrace();
					System.out.println("######################################################");
					System.out.println("Ex200109081513(bbs.pool.connpool2001.PoolChecker.run())::"+e);
				}
			}
		}
		
		if(pool.VERBOSE){
			System.out.println("bbs.pool.connpool2001.PoolChecker.run(), 200109081429 :: "
				+"poolChecker thread is finished");
		}

	}
	catch(Exception e){
		if(pool.VERBOSE){
			System.out.println("Ex200109081700(bbs.pool.connpool2001.PoolChecker.run())::"+e);
		}
	}
	
	
}

}
